_RTCCInterrupt:
;MCU_Interrupt_RTCC.mbas,55 :: 		sub procedure RTCCInterrupt() iv IVT_RTCC ilevel 7 ics ICS_AUTO
RDPGPR	SP, SP
ADDIU	SP, SP, -16
SW	R30, 12(SP)
MFC0	R30, 12, 2
SW	R30, 8(SP)
MFC0	R30, 14, 0
SW	R30, 4(SP)
MFC0	R30, 12, 0
SW	R30, 0(SP)
INS	R30, R0, 1, 15
ORI	R30, R0, 7168
MTC0	R30, 12, 0
ADDIU	SP, SP, -16
SW	RA, 0(SP)
;MCU_Interrupt_RTCC.mbas,56 :: 		RTCCIF_bit = 0 ' Clear T1IF.
LUI	R2, BitMask(RTCCIF_bit+0)
ORI	R2, R2, BitMask(RTCCIF_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,58 :: 		ByteToHex(RTCTIME >> 8, strSecond)                              ' Calgulate Second and convert to String.
LW	R2, Offset(RTCTIME+0)(GP)
SRL	R2, R2, 8
LUI	R26, hi_addr(_strSecond+0)
ORI	R26, R26, lo_addr(_strSecond+0)
MOVZ	R25, R2, R0
JAL	_ByteToHex+0
NOP	
;MCU_Interrupt_RTCC.mbas,59 :: 		ByteToHex(RTCTIME >> 16, strMinute)                             ' Calgulate Minute and convert to String.
LW	R2, Offset(RTCTIME+0)(GP)
SRL	R2, R2, 16
LUI	R26, hi_addr(_strMinute+0)
ORI	R26, R26, lo_addr(_strMinute+0)
MOVZ	R25, R2, R0
JAL	_ByteToHex+0
NOP	
;MCU_Interrupt_RTCC.mbas,60 :: 		ByteToHex(RTCTIME >> 24, strHour)                               ' Calgulate Hour and convert to String.
LW	R2, Offset(RTCTIME+0)(GP)
SRL	R2, R2, 24
LUI	R26, hi_addr(_strHour+0)
ORI	R26, R26, lo_addr(_strHour+0)
MOVZ	R25, R2, R0
JAL	_ByteToHex+0
NOP	
;MCU_Interrupt_RTCC.mbas,61 :: 		strCurrentTime = strHour + ":" + strMinute + ":" + strSecond    ' Calgulate current time.
ADDIU	R3, SP, 4
ADDIU	R2, GP, Offset(_strHour+0)
JAL	___CS2S+0
NOP	
ORI	R4, R0, 58
SB	R4, 0(R3)
ADDIU	R3, R3, 1
ADDIU	R2, GP, Offset(_strMinute+0)
JAL	___CS2S+0
NOP	
ORI	R4, R0, 58
SB	R4, 0(R3)
ADDIU	R3, R3, 1
ADDIU	R2, GP, Offset(_strSecond+0)
JAL	___CS2S+0
NOP	
EXT	R4, R3, 0, 32
SB	R0, 0(R4)
ADDIU	R3, GP, Offset(_strCurrentTime+0)
ADDIU	R2, SP, 4
JAL	___CS2S+0
NOP	
EXT	R4, R3, 0, 32
SB	R0, 0(R4)
;MCU_Interrupt_RTCC.mbas,63 :: 		ByteToHex(RTCDATE >> 8, strDay)                                             ' Calgulate Day and convert to String.
LW	R2, Offset(RTCDATE+0)(GP)
SRL	R2, R2, 8
LUI	R26, hi_addr(_strDay+0)
ORI	R26, R26, lo_addr(_strDay+0)
MOVZ	R25, R2, R0
JAL	_ByteToHex+0
NOP	
;MCU_Interrupt_RTCC.mbas,64 :: 		ByteToHex(RTCDATE >> 16, strMonth)                              ' Calgulate Month and convert to String.
LW	R2, Offset(RTCDATE+0)(GP)
SRL	R2, R2, 16
LUI	R26, hi_addr(_strMonth+0)
ORI	R26, R26, lo_addr(_strMonth+0)
MOVZ	R25, R2, R0
JAL	_ByteToHex+0
NOP	
;MCU_Interrupt_RTCC.mbas,65 :: 		ByteToHex(RTCDATE >> 24, strYear)                               ' Calgulate Year and convert to String.
LW	R2, Offset(RTCDATE+0)(GP)
SRL	R2, R2, 24
LUI	R26, hi_addr(_strYear+0)
ORI	R26, R26, lo_addr(_strYear+0)
MOVZ	R25, R2, R0
JAL	_ByteToHex+0
NOP	
;MCU_Interrupt_RTCC.mbas,66 :: 		strCurrentDate = "20" + strYear + "-" + strMonth + "-" + strDay ' Calgulate current time.
ADDIU	R3, SP, 4
ORI	R4, R0, 50
SB	R4, 0(R3)
ADDIU	R3, R3, 1
ORI	R4, R0, 48
SB	R4, 0(R3)
ADDIU	R3, R3, 1
ADDIU	R2, GP, Offset(_strYear+0)
JAL	___CS2S+0
NOP	
ORI	R4, R0, 45
SB	R4, 0(R3)
ADDIU	R3, R3, 1
ADDIU	R2, GP, Offset(_strMonth+0)
JAL	___CS2S+0
NOP	
ORI	R4, R0, 45
SB	R4, 0(R3)
ADDIU	R3, R3, 1
ADDIU	R2, GP, Offset(_strDay+0)
JAL	___CS2S+0
NOP	
EXT	R4, R3, 0, 32
SB	R0, 0(R4)
ADDIU	R3, GP, Offset(_strCurrentDate+0)
ADDIU	R2, SP, 4
JAL	___CS2S+0
NOP	
EXT	R4, R3, 0, 32
SB	R0, 0(R4)
;MCU_Interrupt_RTCC.mbas,68 :: 		TFT_Set_Font(@Tahoma42x52_Regular, CL_BLUE, FO_HORIZONTAL)      ' Set Font color as background.
MOVZ	R27, R0, R0
ORI	R26, R0, 31
LUI	R25, hi_addr(_Tahoma42x52_Regular+0)
ORI	R25, R25, lo_addr(_Tahoma42x52_Regular+0)
JAL	_TFT_Set_Font+0
NOP	
;MCU_Interrupt_RTCC.mbas,69 :: 		TFT_Write_Text(strPrevTime, 60, 60)                             ' Clear prevous time.
ORI	R27, R0, 60
ORI	R26, R0, 60
LUI	R25, hi_addr(_strPrevTime+0)
ORI	R25, R25, lo_addr(_strPrevTime+0)
JAL	_TFT_Write_Text+0
NOP	
;MCU_Interrupt_RTCC.mbas,70 :: 		TFT_Set_Font(@Tahoma42x52_Regular, CL_BLUE, FO_HORIZONTAL)      ' Set Font color as background.
MOVZ	R27, R0, R0
ORI	R26, R0, 31
LUI	R25, hi_addr(_Tahoma42x52_Regular+0)
ORI	R25, R25, lo_addr(_Tahoma42x52_Regular+0)
JAL	_TFT_Set_Font+0
NOP	
;MCU_Interrupt_RTCC.mbas,71 :: 		TFT_Write_Text(strPrevDate, 60, 120)                             ' Clear prevous time.
ORI	R27, R0, 120
ORI	R26, R0, 60
LUI	R25, hi_addr(_strPrevDate+0)
ORI	R25, R25, lo_addr(_strPrevDate+0)
JAL	_TFT_Write_Text+0
NOP	
;MCU_Interrupt_RTCC.mbas,73 :: 		TFT_Set_Font(@Tahoma42x52_Regular, CL_WHITE, FO_HORIZONTAL)         ' Set Font color as forground.
MOVZ	R27, R0, R0
ORI	R26, R0, 65535
LUI	R25, hi_addr(_Tahoma42x52_Regular+0)
ORI	R25, R25, lo_addr(_Tahoma42x52_Regular+0)
JAL	_TFT_Set_Font+0
NOP	
;MCU_Interrupt_RTCC.mbas,74 :: 		TFT_Write_Text(strCurrentTime, 60, 60)                          ' Print current time.
ORI	R27, R0, 60
ORI	R26, R0, 60
LUI	R25, hi_addr(_strCurrentTime+0)
ORI	R25, R25, lo_addr(_strCurrentTime+0)
JAL	_TFT_Write_Text+0
NOP	
;MCU_Interrupt_RTCC.mbas,75 :: 		TFT_Set_Font(@Tahoma42x52_Regular, CL_WHITE, FO_HORIZONTAL)         ' Set Font color as forground.
MOVZ	R27, R0, R0
ORI	R26, R0, 65535
LUI	R25, hi_addr(_Tahoma42x52_Regular+0)
ORI	R25, R25, lo_addr(_Tahoma42x52_Regular+0)
JAL	_TFT_Set_Font+0
NOP	
;MCU_Interrupt_RTCC.mbas,76 :: 		TFT_Write_Text(strCurrentDAte, 60, 120)                          ' Print current time.
ORI	R27, R0, 120
ORI	R26, R0, 60
LUI	R25, hi_addr(_strCurrentDate+0)
ORI	R25, R25, lo_addr(_strCurrentDate+0)
JAL	_TFT_Write_Text+0
NOP	
;MCU_Interrupt_RTCC.mbas,78 :: 		strPrevTime = strCurrentTime                                    ' Save current time as Prevous time.
ADDIU	R3, GP, Offset(_strPrevTime+0)
ADDIU	R2, GP, Offset(_strCurrentTime+0)
JAL	___CS2S+0
NOP	
EXT	R4, R3, 0, 32
SB	R0, 0(R4)
;MCU_Interrupt_RTCC.mbas,79 :: 		strPrevDate = strCurrentDate                                    ' Save current time as Prevous time.
ADDIU	R3, GP, Offset(_strPrevDate+0)
ADDIU	R2, GP, Offset(_strCurrentDate+0)
JAL	___CS2S+0
NOP	
EXT	R4, R3, 0, 32
SB	R0, 0(R4)
;MCU_Interrupt_RTCC.mbas,81 :: 		LATB.B15 = Not LATB.B15                                         ' One seconds clock counter.
LBU	R2, Offset(LATB+1)(GP)
EXT	R2, R2, 7, 1
XORI	R3, R2, 1
LBU	R2, Offset(LATB+1)(GP)
INS	R2, R3, 7, 1
SB	R2, Offset(LATB+1)(GP)
;MCU_Interrupt_RTCC.mbas,82 :: 		end sub
L_end_RTCCInterrupt:
LW	RA, 0(SP)
ADDIU	SP, SP, 16
DI	
EHB	
LW	R30, 4(SP)
MTC0	R30, 14, 0
LW	R30, 0(SP)
MTC0	R30, 12, 0
LW	R30, 8(SP)
MTC0	R30, 12, 2
LW	R30, 12(SP)
ADDIU	SP, SP, 16
WRPGPR	SP, SP
ERET	
; end of _RTCCInterrupt
_main:
;MCU_Interrupt_RTCC.mbas,84 :: 		main:
;MCU_Interrupt_RTCC.mbas,85 :: 		AD1PCFG  = 0xFFFF               ' Initialize AN pins as digital.
ORI	R2, R0, 65535
SW	R2, Offset(AD1PCFG+0)(GP)
;MCU_Interrupt_RTCC.mbas,87 :: 		TRISB  = 0                      ' Initialize PORTB as output
SW	R0, Offset(TRISB+0)(GP)
;MCU_Interrupt_RTCC.mbas,88 :: 		LATB   = 0                      ' Clear PORTB.
SW	R0, Offset(LATB+0)(GP)
;MCU_Interrupt_RTCC.mbas,91 :: 		TFT_BLED_Direction = 0          ' Set TFT backlight pin as output.
LUI	R2, BitMask(TRISD2_bit+0)
ORI	R2, R2, BitMask(TRISD2_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,92 :: 		TFT_Set_Default_Mode()          ' Set TFT in default mode.
JAL	_TFT_Set_Default_Mode+0
NOP	
;MCU_Interrupt_RTCC.mbas,93 :: 		TFT_Init_ILI9341_8bit(320, 240)        ' Initialize TFT display.
ORI	R26, R0, 240
ORI	R25, R0, 320
JAL	_TFT_Init_ILI9341_8bit+0
NOP	
;MCU_Interrupt_RTCC.mbas,94 :: 		TFT_BLED = 1                    ' Turn on TFT backlight.
LUI	R2, BitMask(LATD2_bit+0)
ORI	R2, R2, BitMask(LATD2_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,95 :: 		TFT_Fill_Screen(CL_BLUE)        ' Clear screen and set background to BLUE.
ORI	R25, R0, 31
JAL	_TFT_Fill_Screen+0
NOP	
;MCU_Interrupt_RTCC.mbas,98 :: 		IPC8 = 0x0E000000               ' Set Interrupt priorities to level 7.
LUI	R2, 3584
SW	R2, Offset(IPC8+0)(GP)
;MCU_Interrupt_RTCC.mbas,99 :: 		RTCCIE_bit = 1                  ' Enable Interrupt.
LUI	R2, BitMask(RTCCIE_bit+0)
ORI	R2, R2, BitMask(RTCCIE_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,102 :: 		RTCALRM = 0xE100                ' Set ALARM Control Register. (As 16 Bit string = "11100001 00000000").
ORI	R2, R0, 57600
SW	R2, Offset(RTCALRM+0)(GP)
;MCU_Interrupt_RTCC.mbas,105 :: 		SYSKEY = 0xAA996655             ' Write first unlock key to SYSKEY
LUI	R2, 43673
ORI	R2, R2, 26197
SW	R2, Offset(SYSKEY+0)(GP)
;MCU_Interrupt_RTCC.mbas,106 :: 		SYSKEY = 0x556699AA             ' Write second unlock key to SYSKEY
LUI	R2, 21862
ORI	R2, R2, 39338
SW	R2, Offset(SYSKEY+0)(GP)
;MCU_Interrupt_RTCC.mbas,108 :: 		RTCWREN_bit = 1                 ' RTC Value registers can be written to by the user
LUI	R2, BitMask(RTCWREN_bit+0)
ORI	R2, R2, BitMask(RTCWREN_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,109 :: 		RTCOE_bit = 1                   ' RTCC pin clock output enabled
LUI	R2, BitMask(RTCOE_bit+0)
ORI	R2, R2, BitMask(RTCOE_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,110 :: 		RTSECSEL_bit = 1                ' RTCC Seconds Clock is selected for the RTCC pin
LUI	R2, BitMask(RTSECSEL_bit+0)
ORI	R2, R2, BitMask(RTSECSEL_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,112 :: 		ON__RTCCON_bit = 0              ' Turn off the RTCC module
LUI	R2, BitMask(ON__RTCCON_bit+0)
ORI	R2, R2, BitMask(ON__RTCCON_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,114 :: 		RTCTIME = 0x23593000            ' Set time. 0xTTMMSS00
LUI	R2, 9049
ORI	R2, R2, 12288
SW	R2, Offset(RTCTIME+0)(GP)
;MCU_Interrupt_RTCC.mbas,115 :: 		RTCDATE = 0x20123100            ' Set date. 0xYYMMDD00 (YY=Only One's and 10's)
LUI	R2, 8210
ORI	R2, R2, 12544
SW	R2, Offset(RTCDATE+0)(GP)
;MCU_Interrupt_RTCC.mbas,117 :: 		ON__RTCCON_bit = 1              ' Turn on the RTCC module
LUI	R2, BitMask(ON__RTCCON_bit+0)
ORI	R2, R2, BitMask(ON__RTCCON_bit+0)
_SX	
;MCU_Interrupt_RTCC.mbas,119 :: 		EnableInterrupts()
EI	R30
;MCU_Interrupt_RTCC.mbas,120 :: 		while TRUE
L__main3:
J	L__main3
NOP	
;MCU_Interrupt_RTCC.mbas,122 :: 		wend
L_end_main:
L__main_end_loop:
J	L__main_end_loop
NOP	
; end of _main
